"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class SelectedReportEvent(ProtocolElement):
    """
    No documentation
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "reportEvent",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_10 import reports as reports_6_4_0

        return {
            "reportEvent": reports_6_4_0.ReportEvent,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        return {}

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_10 import reports as reports_6_4_0

        return {
            "org.gel.models.report.avro.ReportEvent": reports_6_4_0.ReportEvent,
            "org.gel.models.report.avro.SelectedReportEvent": reports_6_4_0.SelectedReportEvent,
        }

    __slots__ = [
        "reportEvent",
        "cipVersion",
        "interpretationService",
    ]

    def __init__(
        self,
        reportEvent,
        cipVersion=None,
        interpretationService=None,
        validate=None,
        **kwargs
    ):
        """Initialise the reports_6_4_0.SelectedReportEvent model.

        :param reportEvent:
            Report event
        :type reportEvent: ReportEvent
        :param cipVersion:
            Interpreted genome version, stored as cip_version in CIPAPI, for the
            interpreted genome this report event was taken from
        :type cipVersion: None | int
        :param interpretationService:
            interpretation service for the interpreted genome this report event
            was taken from
        :type interpretationService: None | str
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "6.4.0"
